﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AitP
{
	public class AitPWorker
	{
		private Main _owner;
		private int _maxPlayers;
		private int _iterations;
		private int _assassinLynchDay;
		public AitPWorker(Main owner, int maxPlayers, int iterations, int assassinLynchDay)
		{
			_owner = owner;
			_maxPlayers = maxPlayers;
			_iterations = iterations;
			_assassinLynchDay = assassinLynchDay;
		}

		public void Run()
		{
			AitPGame game = new AitPGame(_maxPlayers, _assassinLynchDay, _owner.Log);
			_owner.Log("Starting...");
			int townWins = 0;
			int assassinWins = 0;
			int total = 0;
			while (_owner.IsRunning && total < _iterations)
			{
				if (game.Play())
				{
					townWins++;
				}
				else
				{
					assassinWins++;
				}
				total++;
				_owner.Increment();
			}
			_owner.Log(string.Format("Done: Town wins: {0} ({1}%), Assassin wins: {2} ({3}%)", townWins, (townWins * 100/total), assassinWins, (assassinWins * 100/total)));
		}
	}
}
